Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2016779 - Review Request: python-autograd - Efficiently computes derivatives of numpy code
Summary: Review Request: python-autograd - Efficiently computes derivatives of numpy code
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Ankur Sinha (FranciscoD)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR fedora-neuro, NeuroFedora
TreeView+ depends on / blocked
 
Reported: 2021-10-23 17:27 UTC by Adeleye Opeyemi
Modified: 2022-02-23 16:57 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-02-23 16:14:31 UTC
Type: ---
Embargoed:
sanjay.ankur: fedora-review+


Attachments (Terms of Use)

Description Adeleye Opeyemi 2021-10-23 17:27:09 UTC
Spec URL: https://pagure.io/python-autograd/raw/master/f/python-autograd.spec
SRPM URL: https://pagure.io/python-autograd/raw/master/f/python-autograd-1.3-1.fc34.src.rpm

Description: Autograd can automatically differentiate native Python and
Numpy code. It can handle a large subset of Python's features,
including loops, ifs, recursion and closures, and 
it can even take derivatives of derivatives of derivatives.

Fedora Account System Username: hardeborlaa

Comment 1 Adeleye Opeyemi 2021-10-23 18:23:15 UTC
I am a new packager and I need a sponsor.

Comment 2 Vanessa Christopher 2021-10-25 18:40:49 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- source package does not include the text of the license(s) in its own file 
     check with: rpm -ql -L -p results/python3-autograd-1.3-1.fc36.noarch.rpm 

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[-]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 127 files have unknown license. Detailed output of
     licensecheck in
     /home/vanessa/Desktop/contributions/reviews/2016779-python-
     autograd/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-autograd-1.3-1.fc36.noarch.rpm
          python-autograd-1.3-1.fc36.src.rpm
python3-autograd.noarch: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
python-autograd.src: W: spelling-error Summary(en_US) numpy -> bumpy, lumpy, dumpy
python-autograd.src: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
2 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
python3-autograd.noarch: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
The value of this tag appears to be misspelled. Please double-check.

python-autograd.src: W: spelling-error Summary(en_US) numpy -> bumpy, lumpy, dumpy
The value of this tag appears to be misspelled. Please double-check.

python-autograd.src: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
The value of this tag appears to be misspelled. Please double-check.

2 packages and 1 specfiles checked; 0 errors, 3 warnings.


Source checksums
----------------
https://github.com/HIPS/autograd/archive/e12041cc230188342688fd7426e885fd7e7e9f48/python-autograd-e12041c.tar.gz :
  CHECKSUM(SHA256) this package     : e06c6717212c3425bbf0b08c7dabc49360eccb5270a17e2b9e3e90171fa529cd
  CHECKSUM(SHA256) upstream package : e06c6717212c3425bbf0b08c7dabc49360eccb5270a17e2b9e3e90171fa529cd


Requires
--------
python3-autograd (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(future)
    python3.10dist(numpy)



Provides
--------
python3-autograd:
    python-autograd
    python3-autograd
    python3.10-autograd
    python3.10dist(autograd)
    python3dist(autograd)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2016779
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api
Disabled plugins: C/C++, Ocaml, Perl, Java, fonts, Haskell, SugarActivity, R, PHP
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Adeleye Opeyemi 2021-10-26 12:43:42 UTC
Thanks you for the review @vanessaigwe1 

I have included the license text in its own file. Here is the updated Spec and SRPM:

Spec URL- https://pagure.io/python-autograd/raw/master/f/python-autograd.spec

SRPM URL- https://pagure.io/python-autograd/raw/master/f/python-autograd-1.3-1.fc34.src.rpm

Comment 4 AFOLABI, OLUYOSOLA ELIZABETH 2021-10-27 13:19:40 UTC
Package Looks great

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

Generic:
[X]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[X]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 127 files have unknown license. Detailed output of
     licensecheck in /home/oluyosola/2016779-python-
     autograd/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-] Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-autograd-1.3-1.fc36.noarch.rpm
          python-autograd-1.3-1.fc36.src.rpm
python3-autograd.noarch: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
python-autograd.src: W: spelling-error Summary(en_US) numpy -> bumpy, lumpy, dumpy
python-autograd.src: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
2 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/HIPS/autograd/archive/e12041cc230188342688fd7426e885fd7e7e9f48/python-autograd-e12041c.tar.gz :
  CHECKSUM(SHA256) this package     : e06c6717212c3425bbf0b08c7dabc49360eccb5270a17e2b9e3e90171fa529cd
  CHECKSUM(SHA256) upstream package : e06c6717212c3425bbf0b08c7dabc49360eccb5270a17e2b9e3e90171fa529cd


Requires
--------
python3-autograd (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(future)
    python3.10dist(numpy)



Provides
--------
python3-autograd:
    python-autograd
    python3-autograd
    python3.10-autograd
    python3.10dist(autograd)
    python3dist(autograd)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2016779
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api
Disabled plugins: Ocaml, Perl, fonts, PHP, R, SugarActivity, Java, C/C++, Haskell
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 5 Vanessa Christopher 2021-11-01 12:30:23 UTC
(In reply to Adeleye Opeyemi from comment #3)
> Thanks you for the review @vanessaigwe1 
> 
> I have included the license text in its own file. Here is the updated Spec
> and SRPM:
> 
> Spec URL- https://pagure.io/python-autograd/raw/master/f/python-autograd.spec
> 
> SRPM URL-
> https://pagure.io/python-autograd/raw/master/f/python-autograd-1.3-1.fc34.
> src.rpm

This is an unofficial review. I am looking for a sponsor

This looks good :)

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 127 files have unknown license. Detailed output of
     licensecheck in
     /home/vanessa/Desktop/contributions/reviews/2016779-python-
     autograd/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-autograd-1.3-1.fc36.noarch.rpm
          python-autograd-1.3-1.fc36.src.rpm
python3-autograd.noarch: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
python-autograd.src: W: spelling-error Summary(en_US) numpy -> bumpy, lumpy, dumpy
python-autograd.src: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
2 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
python3-autograd.noarch: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
The value of this tag appears to be misspelled. Please double-check.

python-autograd.src: W: spelling-error Summary(en_US) numpy -> bumpy, lumpy, dumpy
The value of this tag appears to be misspelled. Please double-check.

python-autograd.src: W: spelling-error %description -l en_US backpropagation -> back propagation, back-propagation, propagation
The value of this tag appears to be misspelled. Please double-check.

2 packages and 1 specfiles checked; 0 errors, 3 warnings.


Source checksums
----------------
https://github.com/HIPS/autograd/archive/e12041cc230188342688fd7426e885fd7e7e9f48/python-autograd-e12041c.tar.gz :
  CHECKSUM(SHA256) this package     : e06c6717212c3425bbf0b08c7dabc49360eccb5270a17e2b9e3e90171fa529cd
  CHECKSUM(SHA256) upstream package : e06c6717212c3425bbf0b08c7dabc49360eccb5270a17e2b9e3e90171fa529cd


Requires
--------
python3-autograd (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(future)
    python3.10dist(numpy)



Provides
--------
python3-autograd:
    python-autograd
    python3-autograd
    python3.10-autograd
    python3.10dist(autograd)
    python3dist(autograd)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2016779
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api
Disabled plugins: Perl, PHP, R, Haskell, Java, C/C++, fonts, SugarActivity, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 6 Ankur Sinha (FranciscoD) 2021-11-04 20:33:17 UTC
Thanks for your reviews, they're very helpful!

I'm looking at this now.

A few starting points:

- Please remove the quotes (") around the Summary
- Some of your lines have extra spaces at the end (we call them trailing spaces). Can you remove these please?
- i think it's best to use the rpmautospec macros now. So:
* please replace "Release:  1%{?dist}" with "Release: %autorelease"
* please remove all the changelog entries and use "%autochangelog". So it'll become:

%changelog
%autochangelog

Please make these changes and upload the new spec and srpm and I'll do the full review.

Cheers,
Ankur

Comment 7 Adeleye Opeyemi 2021-11-05 06:49:41 UTC
Thanks @FranciscoD. I have made all the changes listed above. Here is the updated spec and srpm:

Spec URL: https://pagure.io/python-autograd/raw/master/f/python-autograd.spec

SRPM URL: https://pagure.io/python-autograd/raw/master/f/python-autograd-1.3-2.fc36.src.rpm

Comment 8 Ankur Sinha (FranciscoD) 2021-11-05 08:40:23 UTC
How was this spec generated? I see them rpmautospec bits on top that I don't think should be there (they don't get added to my specs when I use autorelease etc.). So, is this the spec you wrote or is this the spec generated by `mockbuild` or something?

Also, the spec file linked here does not match the spec file in the src.rpm here. So maybe remove all the rpms from your folder, remove the `## start ...` bits from your spec and re-run `mockbuild` to get a fresh src.rpm that matches your latest spec.

Comment 9 Ankur Sinha (FranciscoD) 2021-11-05 08:41:21 UTC
Here is what fedora-review catches:

Diff spec file in url and in SRPM
---------------------------------
--- /home/asinha/dump/fedora-reviews/2016779-python-autograd/srpm/python-autograd.spec	2021-11-05 08:34:04.747232179 +0000
+++ /home/asinha/dump/fedora-reviews/2016779-python-autograd/srpm-unpacked/python-autograd.spec	2021-11-05 06:21:22.000000000 +0000
@@ -2,4 +2,13 @@
 ## (rpmautospec version 0.2.5)
 %define autorelease(e:s:pb:) %{?-p:0.}%{lua:
+    release_number = 5;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
+## END: Set by rpmautospec
+
+## START: Set by rpmautospec
+## (rpmautospec version 0.2.5)
+%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
     release_number = 2;
     base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
@@ -71,3 +80,16 @@
 
 %changelog
-%autochangelog
+* Fri Nov 05 2021 hardeborlaa <adebola786> 1.3-5
+- Uncommitted changes
+
+* Tue Oct 26 2021 hardeborlaa <adebola786> 1.3-4
+- license text included in its file
+
+* Sat Oct 23 2021 hardeborlaa <adebola786> 1.3-3
+- Add Spec and Srcrpm for Review
+
+* Sat Oct 23 2021 hardeborlaa <adebola786> 1.3-2
+- Add spec and tar file for Review
+
+* Sat Oct 23 2021 hardeborlaa <adebola786> 1.3-1
+- Add Spec and tar file


See how the time stamps for the two specs are different (right on top at the end of the line), so I don't think this src rpm is from your latest spec file.

Comment 10 Adeleye Opeyemi 2021-11-05 09:29:32 UTC
Thanks @FranciscoD. I have made all necessary changes and re-run mockbuild. Here is the updated spec and SRPM:

Spec URL: https://pagure.io/python-autograd/raw/master/f/python-autograd.spec

SRPM URL: https://pagure.io/python-autograd/raw/master/f/python-autograd-1.3-6.fc36.src.rpm

Comment 12 Ankur Sinha (FranciscoD) 2021-12-06 09:13:42 UTC
Looks very very good! Only one or two tweaks and it'll be approved:


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Dist tag is present.
^
using rpmautospec, so this is a false negative.

- Please add a comment at the top to document why we're using a git commit instead of a tag or release
- I see there are examples in the tar, so we should include them if possible.
  It'll require you to include a `-doc` subpackage, though because they're >
  2MB in size:

$ du -sch examples/
2.8M    examples/
2.8M    total


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 127 files have unknown license. Detailed output of
     licensecheck in /home/asinha/dump/fedora-reviews/2016779-python-
     autograd/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
^

$ rpm -ql --licensefiles -p ./python3-autograd-1.3-8.fc36.noarch.rpm 
/usr/share/licenses/python3-autograd/license.txt

[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.

^
Not checked.

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
^
This is because we're using rpmautospec, so it's a false comment.

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Cannot parse rpmlint output:

All OK, run manually:

$ rpmlint *.rpm
======================================================== rpmlint session starts ========================================================
rpmlint: 2.1.0
configuration:
    /usr/lib/python3.10/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/licenses.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 2

python-autograd.src: W: strange-permission python-autograd.spec 600
python-autograd.spec:82: W: macro-in-%changelog %autorelease
python-autograd.spec:82: W: macro-in-%changelog %autochangelog
========================= 2 packages and 0 specfiles checked; 0 errors, 3 warnings, 0 badness; has taken 1.3 s =========================


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Source checksums
----------------
https://github.com/HIPS/autograd/archive/e12041cc230188342688fd7426e885fd7e7e9f48/python-autograd-e12041c.tar.gz :
  CHECKSUM(SHA256) this package     : e06c6717212c3425bbf0b08c7dabc49360eccb5270a17e2b9e3e90171fa529cd
  CHECKSUM(SHA256) upstream package : e06c6717212c3425bbf0b08c7dabc49360eccb5270a17e2b9e3e90171fa529cd


Requires
--------
python3-autograd (rpmlib, GLIBC filtered):
    python(abi)
    python3.10dist(future)
    python3.10dist(numpy)



Provides
--------
python3-autograd:
    python-autograd
    python3-autograd
    python3.10-autograd
    python3.10dist(autograd)
    python3dist(autograd)



Diff spec file in url and in SRPM
---------------------------------
--- /home/asinha/dump/fedora-reviews/2016779-python-autograd/srpm/python-autograd.spec	2021-12-06 08:29:02.028865129 +0000
+++ /home/asinha/dump/fedora-reviews/2016779-python-autograd/srpm-unpacked/python-autograd.spec	2021-11-05 10:38:38.000000000 +0000
@@ -1,2 +1,11 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.2.5)
+%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
+    release_number = 8;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
+## END: Set by rpmautospec
+
 %global commit e12041cc230188342688fd7426e885fd7e7e9f48
 %global shortcommit %(c=%{commit}; echo ${c:0:7})
@@ -61,3 +70,25 @@
 
 %changelog
-%autochangelog
+* Fri Nov 05 2021 Ankur Sinha (Ankur Sinha Gmail) <sanjay.ankur> 1.3-8
+- feat: reformat description
+
+* Fri Nov 05 2021 Ankur Sinha (Ankur Sinha Gmail) <sanjay.ankur> 1.3-7
+- chore: clean up old files
+
+* Fri Nov 05 2021 hardeborlaa <adebola786> 1.3-6
+- spec and srpm updated
+
+* Fri Nov 05 2021 hardeborlaa <adebola786> 1.3-5
+- %autorelease and %autochangelog changes
+
+* Tue Oct 26 2021 hardeborlaa <adebola786> 1.3-4
+- license text included in its file
+
+* Sat Oct 23 2021 hardeborlaa <adebola786> 1.3-3
+- Add Spec and Srcrpm for Review
+
+* Sat Oct 23 2021 hardeborlaa <adebola786> 1.3-2
+- Add spec and tar file for Review
+
+* Sat Oct 23 2021 hardeborlaa <adebola786> 1.3-1
+- Add Spec and tar file


Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 2016779
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Python
Disabled plugins: SugarActivity, Java, fonts, Haskell, R, Perl, C/C++, Ocaml, PHP
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 13 Adeleye Opeyemi 2021-12-11 12:17:31 UTC
Thanks, @FranciscoD for the review. Here is the updated Spec and Srpm

Spec URL: https://pagure.io/python-autograd/raw/master/f/python-autograd.spec

Srpm URL: https://pagure.io/python-autograd/raw/master/f/python-autograd-1.3-8.fc36.src.rpm

Comment 14 Ankur Sinha (FranciscoD) 2022-01-17 13:31:24 UTC
Thanks for that, sorry, it fell off my radar. I'll complete the review again today and provide an update.

Comment 15 Ankur Sinha (FranciscoD) 2022-01-31 10:07:54 UTC
Looks very good.

We do need to split the examples out into a different -doc sub-package. Take a look at this spec, for example:

https://src.fedoraproject.org/rpms/python-pyelectro/blob/rawhide/f/python-pyelectro.spec#_28

You just need to declare a new doc sub-package, and add a new files section for it which contains the examples.

Do ping me in the channels if you have any queries about what to do here.

Cheers,

Comment 16 Adeleye Opeyemi 2022-02-10 12:24:52 UTC
Thanks for the review. I will make the necessary changes and provide an update.

Comment 19 Ankur Sinha (FranciscoD) 2022-02-11 13:51:05 UTC
OK, that looks good now! 👏

XXX APPROVED XXX

Please continue from step 7 here:
https://docs.fedoraproject.org/en-US/package-maintainers/New_Package_Process_for_Existing_Contributors/

When the repo is ready on src.fedoraproject.org, you'll have to use the steps here to import the package again:
https://pagure.io/fedora-docs/package-maintainer-docs/issue/56

Please ping us anytime if you have any questions about this.

Comment 20 Gwyn Ciesla 2022-02-14 15:17:44 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-autograd

Comment 21 Fedora Update System 2022-02-15 12:24:37 UTC
FEDORA-2022-ec2a944a1b has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2022-ec2a944a1b

Comment 22 Fedora Update System 2022-02-15 12:24:38 UTC
FEDORA-2022-9a30710b7e has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2022-9a30710b7e

Comment 23 Fedora Update System 2022-02-16 01:50:37 UTC
FEDORA-2022-9a30710b7e has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2022-9a30710b7e \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-9a30710b7e

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 24 Fedora Update System 2022-02-16 02:04:42 UTC
FEDORA-2022-ec2a944a1b has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2022-ec2a944a1b \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-ec2a944a1b

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 25 Fedora Update System 2022-02-23 16:14:31 UTC
FEDORA-2022-ec2a944a1b has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 26 Fedora Update System 2022-02-23 16:57:01 UTC
FEDORA-2022-9a30710b7e has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.